import { __assign } from 'tslib';
import { createElement } from 'react';
import { featureDefinitions } from './definitions.js';

var featureNames = Object.keys(featureDefinitions);
var numFeatures = featureNames.length;
/**
 * Load features via renderless components based on the provided MotionProps.
 * TODO: Look into porting this to a component-less appraoch.
 */
function useFeatures(props, visualElement) {
    var features = [];
    if (!visualElement)
        return null;
    for (var i = 0; i < numFeatures; i++) {
        var name_1 = featureNames[i];
        var _a = featureDefinitions[name_1], isEnabled = _a.isEnabled, Component = _a.Component;
        if (isEnabled(props)) {
            if (Component) {
                features.push(createElement(Component, __assign({ key: name_1 }, props, { visualElement: visualElement })));
            }
        }
    }
    return features;
}

export { useFeatures };
